<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class BandeiraFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function getFlags($row){
        $sql = "SELECT DAT.NRBANDEIRAVAN, DAT.NMBANDEIRA, DAT.CDBANDEIRA, DAT.CDBANDEIRA||' - '||DAT.NMBANDEIRA AS LABELBANDEIRA, 
         N FROM 
               (SELECT D.*, ROWNUM as N 
                FROM 
                     (SELECT NRBANDEIRAVAN, NMBANDEIRA, CDBANDEIRA, CDBANDEIRA||' - '||NMBANDEIRA AS LABELBANDEIRA, NRORG
                       FROM BANDEIRAVAN 
                       WHERE UPPER (CDBANDEIRA||' - '||NMBANDEIRA) LIKE UPPER (:LABELBANDEIRA)
                        AND IDVISIVEL = 'S'
                        AND IDATIVO = 'S'
                       ) D ) DAT 
            WHERE DAT.NRORG = :NRORG
            ORDER BY LABELBANDEIRA";
        $std = $this->connection->prepare($sql);
        $std->execute($row);
        return $std->fetchAll();
    }
    
    public function loadFlagByname($params){
        $sql = "SELECT NRBANDEIRAVAN 
                 FROM BANDEIRAVAN 
                  WHERE NMBANDEIRA = :NMBANDEIRA";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

}
