<?php

namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc02300StatusVendasFactory {
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getStatusVendas ($params) {
        $sql = "SELECT COUNT(R.IDSITUACAO) QTDVENDA, DECODE(R.IDSITUACAO, 'C', 'Corretas', 'N', 'Não Conciliadas', 'O', 'Corrigidas') LABELCONC
                FROM RETVENDAADQ R
                WHERE R.NRORG = :NRORG
                  AND ((INSTR(:NRPRODUTOADQ, '|'||R.NRPRODUTOADQ||'|')>0) OR ('T' = :TNRPRODUTOADQ))
                  AND ((INSTR(:NRESTABELEC, '|'||R.NRESTABELEC||'|')>0) OR ('T' = :TNRESTABELEC))
                  AND R.DTVENDA BETWEEN :DTVENDA_INI AND :DTVENDA_FIM
                  AND R.IDSITUACAO IN ('C',  'N', 'O')
                GROUP BY R.IDSITUACAO";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getStatusVendasDetails ($params) {
        $sql = "SELECT * FROM (
                    SELECT R.IDSITUACAO PRIMARY, NULL PARENT, DECODE(R.IDSITUACAO, 'C', 'Correto', 'O', 'Corrigido', 'N', 
                      'Não Conciliada') STATUS, NULL CDESTABELEC, NULL NMESTABELEC, NULL NMPRODUTOADQ, NULL DTVENDA, NULL CDNSU, 
                      NULL NRAUTORIZACAO, NULL VRBRUTVENDA
                    FROM RETVENDAADQ R
                    WHERE R.NRORG = :NRORG
                    
                    UNION
                    
                    SELECT TO_CHAR(R.NRRETVENDAADQ) PRIMARY, R.IDSITUACAO PARENT, NULL STATUS, E.CDESTABELEC, E.NMESTABELEC, 
                    P.NMPRODUTOADQ, TO_CHAR(R.DTVENDA, 'DD/MM/YYYY'), R.CDNSU, R.NRAUTORIZACAO, R.VRBRUTVENDA
                    FROM RETVENDAADQ R, ESTABELECIMENTO E, PRODUTOADQ P
                    WHERE R.NRORG = :NRORG
                      AND (INSTR(:NRESTABELEC, '|'||E.NRESTABELEC||'|') > 0 OR ('T' = :TNRESTABELEC))
                      AND (INSTR(:NRPRODUTOADQ, '|'||P.NRPRODUTOADQ||'|') > 0 OR ('T' = :TNRPRODUTOADQ))
                      AND R.NRESTABELEC = E.NRESTABELEC
                      AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                      AND R.DTVENDA BETWEEN :DTVENDA_INI AND :DTVENDA_FIM
                ) T
                ORDER BY T.DTVENDA, T.NMESTABELEC, T.VRBRUTVENDA, T.CDNSU";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
}